﻿# Raumplaner2012MitShell.py
# Einbau einer interaktiven Shell nach "wxPython in Action"
import wx

from ShellFuerGui import FuerGui

import colorsys
from math import cos, sin, radians

USE_BUFFER = ('wxMSW' in wx.PlatformInfo) # use buffered drawing on Windows


### ---------------------------------------------------
class Tisch:
    def __init__(self, xPos=0, yPos=0, breite=100, tiefe=60, winkel=0, farbe="black", sichtbar=True):
        self.x=xPos
        self.y=yPos
        self.b=breite
        self.t=tiefe
        self.w=winkel
        self.f=farbe
        self.s=sichtbar
        
    def GibFigur(self):
        panel = Fenster.GibZeichenflaeche()
        path = panel.GibGC().CreatePath()
        path.AddRectangle(0, 0, self.b, self.t)
        self.transformiere()
        return path
    
    def BewegeHorizontal(self, weite):
        self.Verberge()
        self.x+=weite
        self.Zeige()
    
    def BewegeVertikal(self, weite):
        self.Verberge()
        self.y+=weite
        self.Zeige()
    
    def Drehe(self, winkel):
        self.Verberge()
        self.w+=winkel
        self.Zeige()

    def Verberge(self):
        self.s = False
        self.Zeichne()

    def Zeige(self):
        self.s = True
        self.Zeichne()

    def GibFarbe(self):
        return self.f
    
    def transformiere(self):
        # Now use that path
        gc=Fenster.GibZeichenflaeche().GibGC()
        gc.Translate(self.x+self.b/2, self.y+self.t/2)
        gc.Rotate(radians(self.w))
        gc.Translate(-self.b/2, -self.t/2)

    def Zeichne(self):
        Fenster.GibZeichenflaeche().Zeichne(self)        

    
### ---------------------------------------------------
class Stuhl:
    def __init__(self, xPos=0, yPos=0, breite=40, tiefe=40, winkel=0, farbe="black", sichtbar=True):
        self.x=xPos
        self.y=yPos
        self.b=breite
        self.t=tiefe
        self.w=winkel
        self.f=farbe
        self.s=sichtbar
        
    def GibFigur(self):
        panel = Fenster.GibZeichenflaeche()
        path = panel.GibGC().CreatePath()
        path.MoveToPoint(0, 0)
        path.AddLineToPoint(self.b, 0)
        path.AddLineToPoint(self.b*1.1, self.t)
        path.AddLineToPoint(-self.b*0.1, self.t)
        path.AddLineToPoint(0, 0)
        path.AddLineToPoint(0, -self.t*0.1)
        path.AddLineToPoint(self.b, -self.t*0.1)
        path.AddLineToPoint(self.b, 0)
        self.transformiere()
        return path

    def BewegeHorizontal(self, weite):
        self.Verberge()
        self.x+=weite
        self.Zeige()
    
    def BewegeVertikal(self, weite):
        self.Verberge()
        self.y+=weite
        self.Zeige()
    
    def Drehe(self, winkel):
        self.Verberge()
        self.w+=winkel
        self.Zeige()

    def Verberge(self):
        self.s = False
        self.Zeichne()

    def Zeige(self):
        self.s = True
        self.Zeichne()

    def GibFarbe(self):
        return self.f
    
    def transformiere(self):
        # Now use that path
        gc=Fenster.GibZeichenflaeche().GibGC()
        gc.Translate(self.x+self.b/2, self.y+self.t/2)
        gc.Rotate(radians(self.w))
        gc.Translate(-self.b/2, -self.t/2)

    def Zeichne(self):
        Fenster.GibZeichenflaeche().Zeichne(self)        

### ---------------------------------------------------
class Zeichenflaeche(wx.Panel):    
    def __init__(self, parent):
        wx.Panel.__init__(self, parent, -1)
        self.Bind(wx.EVT_PAINT, self.OnPaint)
        if USE_BUFFER:
            self.Bind(wx.EVT_SIZE, self.OnSize)
        self.objekte = []
        self.anzahl = 0
        self.gc = None

    def OnSize(self, evt):
        self.InitBuffer()
        evt.Skip()

    def OnPaint(self, evt):
        self.InitBuffer() # Das ist die Loesung der Windows-Probleme !!!
        if USE_BUFFER:
            # The buffer already contains our drawing, so no need to
            # do anything else but create the buffered DC.  When this
            # method exits and dc is collected then the buffer will be
            # blitted to the paint DC automagically
            dc = wx.BufferedPaintDC(self, self._buffer)
        else:
            # Otherwise we need to draw our content to the paint DC at
            # this time.
            dc = wx.PaintDC(self)
            gc = self.MakeGC(dc)
            self.Draw(gc)

    def InitBuffer(self):
        sz = self.GetClientSize()
        sz.width = max(1, sz.width)
        sz.height = max(1, sz.height)
        self._buffer = wx.EmptyBitmap(sz.width, sz.height, 32)
        dc = wx.MemoryDC(self._buffer)
        dc.SetBackground(wx.Brush("WHITE")) # Original:self.GetBackgroundColour()
        dc.Clear()
        gc = self.MakeGC(dc)
        self.Draw(gc)
        
    def MakeGC(self, dc):
        try:
            gc = wx.GraphicsContext.Create(dc)
        except NotImplementedError:
            dc.DrawText("This build of wxPython does not support the wx.GraphicsContext "
                        "family of classes.",
                        25, 25)
            return None
        self.gc = gc
        return gc

    def Draw(self, gc):
        font = wx.SystemSettings.GetFont(wx.SYS_DEFAULT_GUI_FONT)
        font.SetWeight(wx.BOLD)
        gc.SetFont(font)

        # weissen Hintergrund zeichnen
        back = gc.CreatePath()
        gc.PushState()  # save current translation/scale/other state 
        back.AddRectangle(0, 0, self.GetClientSize().width, self.GetClientSize().height)
        gc.SetBrush(wx.Brush('white'))
        gc.FillPath(back)          # nur Fuellung
        gc.PopState()              # restore saved state
        
        for objekt in self.objekte:
            if objekt.s:
                path = gc.CreatePath()            
                gc.PushState()
                path.AddPath(objekt.GibFigur())
                gc.SetPen(wx.Pen(objekt.GibFarbe()))
                gc.DrawPath(path)
                gc.PopState()

    # Erweiterungen für das Raumplanerprojekt:
    def Zeichne(self, objekt):
        self.objekte+=[objekt]
        self.Refresh()

    def GibGC(self):
        return self.gc
        

### ---------------------------------------------------
class Fenster(wx.Frame, FuerGui):
    """
    Die Klasse Fenster erzeugt einen Frame.
    """
    __zeichenflaeche=None
    def GibZeichenflaeche():
        return Fenster.__zeichenflaeche
    GibZeichenflaeche=staticmethod(GibZeichenflaeche)
    
    def __init__(self, parent, title):
        wx.Frame.__init__(self, parent, -1, title,
                          pos=(50, 50), size=(400, 400))
        FuerGui.__init__(self, self)
        self.panel = Zeichenflaeche(self)
        Fenster.__zeichenflaeche=self.panel
        

### ---------------------------------------------------
class MyApp(wx.App):
    def OnInit(self):
        self.fenster = Fenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        self.Anwendung()
        return True

    def Anwendung(self):
        tisch1 = Tisch(60, 60, 120, 60, farbe='orange')
        tisch1.Zeichne()
        stuhl1 = Stuhl(10, 70, 40, 40, 270, 'blue')
        stuhl1.Zeichne()
        stuhl2 = Stuhl(70, 10, 40, 40, 0, 'blue')
        stuhl2.Zeichne()
        stuhl3 = Stuhl(130, 10, 40, 40, 0, 'blue')
        stuhl3.Zeichne()
        stuhl4 = Stuhl(190, 70, 40, 40, 90, 'blue')
        stuhl4.Zeichne()
        stuhl5 = Stuhl(70, 130, 40, 40, 180, 'blue')
        stuhl5.Zeichne()
        stuhl6 = Stuhl(130, 130, 40, 40, 180, 'blue')
        stuhl6.Zeichne()
        
### ---------------------------------------------------
if __name__ == '__main__':
    app = MyApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
